#ifndef MSP_VR_STEREOCOMBINER_H_
#define MSP_VR_STEREOCOMBINER_H_

#include <msp/geometry/angle.h>
#include <msp/gl/texture2d.h>

namespace Msp {
namespace VR {

class StereoCombiner
{
protected:
	unsigned width_div;
	unsigned height_div;
	bool keep_aspect;
	Geometry::Angle<float> fov;
	float oversize;

	StereoCombiner();
public:
	virtual ~StereoCombiner() { }

	unsigned get_width_divisor() const { return width_div; }
	unsigned get_height_divisor() const { return height_div; }
	bool is_aspect_kept() const { return keep_aspect; }
	const Geometry::Angle<float> &get_field_of_view() const { return fov; }
	float get_oversize() const { return oversize; }

	virtual void render(const GL::Texture2D &, const GL::Texture2D &) const = 0;
};

} // namespace VR
} // namespace Msp

#endif
